#ifndef IOBOARD_TCP_DEFS_H
#define IOBOARD_TCP_DEFS_H

const std::uint32_t PACKET_MAGIC				= 0x11223456;

const std::uint32_t PACKET_DATA_REQUEST			= 0x00000001;
const std::uint32_t PACKET_DATA					= 0x00000002;
const std::uint32_t PACKET_DATA_DO				= 0x00000003;
const std::uint32_t PACKET_CALIBRATION_CMD		= 0x00000008;
const std::uint32_t PACKET_SETTINGS_SET			= 0x0000000C;
const std::uint32_t PACKET_SETTINGS_GET			= 0x0000000D;
const std::uint32_t PACKET_IDENTIFICATION		= 0x0000000E;
const std::uint32_t PACKET_RESET				= 0x115511FF;

const std::uint32_t PACKET_BOOT					= 0x11552233;

const std::uint8_t CALIBRATION_RESET               = 0xFA;
const std::uint8_t CALIBRATION_POINT_MIN           = 0xFB;
const std::uint8_t CALIBRATION_POINT_CENTER        = 0xFC;
const std::uint8_t CALIBRATION_POINT_CENTER_AUTO   = 0xFD;
const std::uint8_t CALIBRATION_POINT_MAX           = 0xFE;
const std::uint8_t CALIBRATION_SAVE                = 0xFF;

#pragma pack(1)

typedef struct 
{
	std::uint32_t	magic;
	std::uint32_t	packet_type;
	std::uint32_t	length;
} IO_BOARD_PACKET_HEADER;

#pragma pack()

#endif