
// IO_board_usb_ethDlg.cpp : implementation file
//

#include "stdafx.h"
#include "IO_board_usb_eth.h"
#include "IO_board_usb_ethDlg.h"
#include "afxdialogex.h"
#include <string>
#include <cstdio>
#include <stdlib.h> 
#include <crtdbg.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

std::string string_format(const std::string fmt, ...) 
{
    int size = ((int)fmt.size()) * 2 + 50; 
    std::string str;
    va_list ap;
    while (1) 
	{
        str.resize(size);
        va_start(ap, fmt);
        int n = vsnprintf_s((char *)str.data(), size,  _TRUNCATE,  fmt.c_str(), ap);
        va_end(ap);
        if (n > -1 && n < size) 
		{
            str.resize(n);
            return str;
        }
        if (n > -1)
            size = n + 1;
        else
            size *= 2;
    }
    return str;
}

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()

//-------------------------------------------------------------------------------
template<typename TYPE> static std::string binary_print(TYPE x)
{
   typedef std::make_unsigned<TYPE>::type uTYPE;   
   std::string str;
   unsigned u=0;
   for(uTYPE i = ~((uTYPE)~0 >> 1LL); i; i >>= 1LL)
   {
		if((u%4)==0) str += ' ';
		u++;
		str += '0' + ((x & i) > 0);
   }
  return str;
}

// CIO_board_usb_ethDlg dialog
//-------------------------------------------------------------------------------


CIO_board_usb_ethDlg::CIO_board_usb_ethDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CIO_board_usb_ethDlg::IDD, pParent)
	//, isConnected(false)
	//, device(NULL)
	, change_outputs(false)
	, m_do_mode(0)
	, io_board(NULL)
	, bootloader(NULL)
	, m_connection_type(0)
	, m_port(5000)
	, m_connect(FALSE)
	, m_mac1(0x00)
	, m_mac2(0x08)
	, m_mac3(0xdc)
	, m_mac4(0xab)
	, m_mac5(0xcd)
	, m_mac6(0xef)
	, m_settings_port(5000)
	, m_calib_select(0)
	, m_monitoring(FALSE)
	, m_pwm1(0)
	, m_pwm2(0)
	, m_filename_hex(_T(""))
	, m_connect_bootloader(FALSE)
	, m_pwm_init_1(0)
	, m_pwm_init_2(0)
	, m_blink_once(FALSE)
{
#ifdef _DEBUG
	_CrtSetDbgFlag ( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF );
#endif

	for(int i=0;i<BOARD_MODEL_1_DO;i++)
	{
		m_out[i] = FALSE;
		m_settings_startup[i]=FALSE;
	}
	for(int i=0;i<BOARD_MODEL_1_AI;i++)
	{
		m_ai[i] = 0;
		m_ai_enable[i]=TRUE;
	}

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	bitmap_off = LoadBitmap(AfxGetInstanceHandle( ), MAKEINTRESOURCE(IDB_BITMAP_GREEN));
	bitmap_on = LoadBitmap(AfxGetInstanceHandle( ), MAKEINTRESOURCE(IDB_BITMAP_RED));

	icon_unknown = LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_UNKNOWN));
	icon_on		 = LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_ON));
	icon_on_err	 = LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_ON_ERROR));
	icon_off	 = LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_OFF));
	icon_off_err = LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_OFF_ERROR));
}

void CIO_board_usb_ethDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STATIC1, m_in[0]);
	DDX_Control(pDX, IDC_STATIC2, m_in[1]);
	DDX_Control(pDX, IDC_STATIC3, m_in[2]);
	DDX_Control(pDX, IDC_STATIC4, m_in[3]);
	DDX_Control(pDX, IDC_STATIC5, m_in[4]);
	DDX_Control(pDX, IDC_STATIC6, m_in[5]);
	DDX_Control(pDX, IDC_STATIC7, m_in[6]);
	DDX_Control(pDX, IDC_STATIC8, m_in[7]);
	DDX_Control(pDX, IDC_STATIC9,  m_in[8]);
	DDX_Control(pDX, IDC_STATIC10, m_in[9]);
	DDX_Control(pDX, IDC_STATIC11, m_in[10]);
	DDX_Control(pDX, IDC_STATIC12, m_in[11]);
	DDX_Control(pDX, IDC_STATIC13, m_in[12]);
	DDX_Control(pDX, IDC_STATIC14, m_in[13]);
	DDX_Control(pDX, IDC_STATIC15, m_in[14]);
	DDX_Control(pDX, IDC_STATIC16, m_in[15]);
	DDX_Control(pDX, IDC_STATIC17, m_in[16]);
	DDX_Control(pDX, IDC_STATIC18, m_in[17]);
	DDX_Control(pDX, IDC_STATIC19, m_in[18]);
	DDX_Control(pDX, IDC_STATIC20, m_in[19]);
	DDX_Control(pDX, IDC_STATIC21, m_in[20]);
	DDX_Control(pDX, IDC_STATIC22, m_in[21]);
	DDX_Control(pDX, IDC_STATIC23, m_in[22]);
	DDX_Control(pDX, IDC_STATIC24, m_in[23]);
	DDX_Radio(pDX, IDC_DO_MODE1, m_do_mode);
	DDX_Check(pDX, IDC_OUT1, m_out[0]);
	DDX_Check(pDX, IDC_OUT2, m_out[1]);
	DDX_Check(pDX, IDC_OUT3, m_out[2]);
	DDX_Check(pDX, IDC_OUT4, m_out[3]);
	DDX_Check(pDX, IDC_OUT5, m_out[4]);
	DDX_Check(pDX, IDC_OUT6, m_out[5]);
	DDX_Check(pDX, IDC_OUT7, m_out[6]);
	DDX_Check(pDX, IDC_OUT8, m_out[7]);
	DDX_Check(pDX, IDC_OUT9, m_out[8]);
	DDX_Check(pDX, IDC_OUT10, m_out[9]);
	DDX_Check(pDX, IDC_OUT11, m_out[10]);
	DDX_Check(pDX, IDC_OUT12, m_out[11]);
	DDX_Check(pDX, IDC_OUT13, m_out[12]);
	DDX_Check(pDX, IDC_OUT14, m_out[13]);
	DDX_Check(pDX, IDC_OUT15, m_out[14]);
	DDX_Check(pDX, IDC_OUT16, m_out[15]);
	DDX_Control(pDX, IDC_PROGRESS1, m_progress_ai[0]);
	DDX_Control(pDX, IDC_PROGRESS2, m_progress_ai[1]);
	DDX_Control(pDX, IDC_PROGRESS3, m_progress_ai[2]);
	DDX_Control(pDX, IDC_PROGRESS4, m_progress_ai[3]);
	DDX_Control(pDX, IDC_PROGRESS5, m_progress_ai[4]);
	DDX_Control(pDX, IDC_PROGRESS6, m_progress_ai[5]);
	DDX_Control(pDX, IDC_PROGRESS7, m_progress_ai[6]);
	DDX_Control(pDX, IDC_PROGRESS8, m_progress_ai[7]);
	DDX_Control(pDX, IDC_PROGRESS9, m_progress_ai[8]);
	DDX_Control(pDX, IDC_PROGRESS10, m_progress_ai[9]);
	DDX_Text(pDX, IDC_AI_EDIT1, m_ai[0]);
	DDX_Text(pDX, IDC_AI_EDIT2, m_ai[1]);
	DDX_Text(pDX, IDC_AI_EDIT3, m_ai[2]);
	DDX_Text(pDX, IDC_AI_EDIT4, m_ai[3]);
	DDX_Text(pDX, IDC_AI_EDIT5, m_ai[4]);
	DDX_Text(pDX, IDC_AI_EDIT6, m_ai[5]);
	DDX_Text(pDX, IDC_AI_EDIT7, m_ai[6]);
	DDX_Text(pDX, IDC_AI_EDIT8, m_ai[7]);
	DDX_Text(pDX, IDC_AI_EDIT9, m_ai[8]);
	DDX_Text(pDX, IDC_AI_EDIT10, m_ai[9]);
	DDX_Radio(pDX, IDC_CONNECTION_TYPE_USB, m_connection_type);
	DDX_Control(pDX, IDC_IPADDRESS1, m_ip);
	DDX_Text(pDX, IDC_PORT, m_port);
	DDX_Check(pDX, IDC_CONNECT, m_connect);
	DDX_Check(pDX, IDC_STARTUP_1, m_settings_startup[0]);
	DDX_Check(pDX, IDC_STARTUP_2, m_settings_startup[1]);
	DDX_Check(pDX, IDC_STARTUP_3, m_settings_startup[2]);
	DDX_Check(pDX, IDC_STARTUP_4, m_settings_startup[3]);
	DDX_Check(pDX, IDC_STARTUP_5, m_settings_startup[4]);
	DDX_Check(pDX, IDC_STARTUP_6, m_settings_startup[5]);
	DDX_Check(pDX, IDC_STARTUP_7, m_settings_startup[6]);
	DDX_Check(pDX, IDC_STARTUP_8, m_settings_startup[7]);
	DDX_Check(pDX, IDC_STARTUP_9, m_settings_startup[8]);
	DDX_Check(pDX, IDC_STARTUP_10, m_settings_startup[9]);
	DDX_Check(pDX, IDC_STARTUP_11, m_settings_startup[10]);
	DDX_Check(pDX, IDC_STARTUP_12, m_settings_startup[11]);
	DDX_Check(pDX, IDC_STARTUP_13, m_settings_startup[12]);
	DDX_Check(pDX, IDC_STARTUP_14, m_settings_startup[13]);
	DDX_Check(pDX, IDC_STARTUP_15, m_settings_startup[14]);
	DDX_Check(pDX, IDC_STARTUP_16, m_settings_startup[15]);
	DDX_Check(pDX, IDC_ENABLE_1, m_ai_enable[0]);
	DDX_Check(pDX, IDC_ENABLE_2, m_ai_enable[1]);
	DDX_Check(pDX, IDC_ENABLE_3, m_ai_enable[2]);
	DDX_Check(pDX, IDC_ENABLE_4, m_ai_enable[3]);
	DDX_Check(pDX, IDC_ENABLE_5, m_ai_enable[4]);
	DDX_Check(pDX, IDC_ENABLE_6, m_ai_enable[5]);
	DDX_Check(pDX, IDC_ENABLE_7, m_ai_enable[6]);
	DDX_Check(pDX, IDC_ENABLE_8, m_ai_enable[7]);
	DDX_Check(pDX, IDC_ENABLE_9, m_ai_enable[8]);
	DDX_Check(pDX, IDC_ENABLE_10, m_ai_enable[9]);
	DDX_Text(pDX, IDC_MAC1, m_mac1);
	DDX_Text(pDX, IDC_MAC2, m_mac2);
	DDX_Text(pDX, IDC_MAC3, m_mac3);
	DDX_Text(pDX, IDC_MAC4, m_mac4);
	DDX_Text(pDX, IDC_MAC5, m_mac5);
	DDX_Text(pDX, IDC_MAC6, m_mac6);
	DDX_Text(pDX, IDC_SETTINGS_PORT, m_settings_port);
	DDX_Control(pDX, IDC_SETTINGS_IP, m_settings_ip);
	DDX_Control(pDX, IDC_SETTINGS_MASK, m_settings_mask);
	DDX_Control(pDX, IDC_SETTINGS_GW, m_settings_gw);
	DDX_Radio(pDX, IDC_CORR1, m_calib_select);
	DDX_Check(pDX, IDC_MONITORING, m_monitoring);
	DDX_Control(pDX, IDC_SCROLLBAR_PWM1, m_scroll_pwm1);
	DDX_Control(pDX, IDC_SCROLLBAR_PWM2, m_scroll_pwm2);
	DDX_Text(pDX, IDC_PWM1, m_pwm1);
	DDX_Text(pDX, IDC_PWM2, m_pwm2);
	DDX_Text(pDX, IDC_FILENAME_HEX, m_filename_hex);
	DDX_Check(pDX, IDC_CONNECT_BOOTLOADER, m_connect_bootloader);
	DDX_Text(pDX, IDC_PWM1_INIT, m_pwm_init_1);
	DDV_MinMaxUInt(pDX, m_pwm_init_1, 0, 1023);
	DDX_Text(pDX, IDC_PWM2_INIT, m_pwm_init_2);
	DDV_MinMaxUInt(pDX, m_pwm_init_2, 0, 1023);
	DDX_Check(pDX, IDC_BLINK_ONCE, m_blink_once);
}

BEGIN_MESSAGE_MAP(CIO_board_usb_ethDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CREATE()
	ON_WM_CLOSE()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDOK, &CIO_board_usb_ethDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &CIO_board_usb_ethDlg::OnBnClickedCancel)
	ON_BN_CLICKED(IDC_OUT1, &CIO_board_usb_ethDlg::OnBnClickedOut1)
	ON_BN_CLICKED(IDC_OUT2, &CIO_board_usb_ethDlg::OnBnClickedOut2)
	ON_BN_CLICKED(IDC_OUT3, &CIO_board_usb_ethDlg::OnBnClickedOut3)
	ON_BN_CLICKED(IDC_OUT4, &CIO_board_usb_ethDlg::OnBnClickedOut4)
	ON_BN_CLICKED(IDC_OUT5, &CIO_board_usb_ethDlg::OnBnClickedOut5)
	ON_BN_CLICKED(IDC_OUT6, &CIO_board_usb_ethDlg::OnBnClickedOut6)
	ON_BN_CLICKED(IDC_OUT7, &CIO_board_usb_ethDlg::OnBnClickedOut7)
	ON_BN_CLICKED(IDC_OUT8, &CIO_board_usb_ethDlg::OnBnClickedOut8)
	ON_BN_CLICKED(IDC_OUT9, &CIO_board_usb_ethDlg::OnBnClickedOut9)
	ON_BN_CLICKED(IDC_OUT10, &CIO_board_usb_ethDlg::OnBnClickedOut10)
	ON_BN_CLICKED(IDC_OUT11, &CIO_board_usb_ethDlg::OnBnClickedOut11)
	ON_BN_CLICKED(IDC_OUT12, &CIO_board_usb_ethDlg::OnBnClickedOut12)
	ON_BN_CLICKED(IDC_OUT13, &CIO_board_usb_ethDlg::OnBnClickedOut13)
	ON_BN_CLICKED(IDC_OUT14, &CIO_board_usb_ethDlg::OnBnClickedOut14)
	ON_BN_CLICKED(IDC_OUT15, &CIO_board_usb_ethDlg::OnBnClickedOut15)
	ON_BN_CLICKED(IDC_OUT16, &CIO_board_usb_ethDlg::OnBnClickedOut16)
	ON_BN_CLICKED(IDC_DO_MODE1, &CIO_board_usb_ethDlg::OnBnClickedDoMode)
	ON_BN_CLICKED(IDC_DO_MODE8, &CIO_board_usb_ethDlg::OnBnClickedDoMode)
	ON_BN_CLICKED(IDC_DO_MODE2, &CIO_board_usb_ethDlg::OnBnClickedDoMode)
	ON_BN_CLICKED(IDC_DO_MODE3, &CIO_board_usb_ethDlg::OnBnClickedDoMode)
	ON_BN_CLICKED(IDC_DO_MODE4, &CIO_board_usb_ethDlg::OnBnClickedDoMode)
	ON_BN_CLICKED(IDC_DO_MODE5, &CIO_board_usb_ethDlg::OnBnClickedDoMode)
	ON_BN_CLICKED(IDC_DO_MODE6, &CIO_board_usb_ethDlg::OnBnClickedDoMode)
	ON_BN_CLICKED(IDC_DO_MODE7, &CIO_board_usb_ethDlg::OnBnClickedDoMode)
	ON_BN_CLICKED(IDC_CONNECTION_TYPE_USB, &CIO_board_usb_ethDlg::OnBnClickedConnectionTypeUsb)
	ON_BN_CLICKED(IDC_CONNECTION_TYPE_TCP, &CIO_board_usb_ethDlg::OnBnClickedConnectionTypeTcp)
	ON_BN_CLICKED(IDC_CONNECT, &CIO_board_usb_ethDlg::OnBnClickedConnect)
	ON_BN_CLICKED(IDC_SETTINGS_SET, &CIO_board_usb_ethDlg::OnBnClickedSettingsSet)
	ON_BN_CLICKED(IDC_CALIB_MIN, &CIO_board_usb_ethDlg::OnBnClickedCalibMin)
	ON_BN_CLICKED(IDC_CALIB_CENTER, &CIO_board_usb_ethDlg::OnBnClickedCalibCenter)
	ON_BN_CLICKED(IDC_CALIB_MAX, &CIO_board_usb_ethDlg::OnBnClickedCalibMax)
	ON_BN_CLICKED(IDC_CALIB_SAVE, &CIO_board_usb_ethDlg::OnBnClickedCalibSave)
	ON_BN_CLICKED(IDC_CALIB_RESET, &CIO_board_usb_ethDlg::OnBnClickedCalibReset)
	ON_BN_CLICKED(IDC_RESET, &CIO_board_usb_ethDlg::OnBnClickedReset)
	ON_BN_CLICKED(IDC_SETTINGS_GET, &CIO_board_usb_ethDlg::OnBnClickedSettingsGet)
	ON_BN_CLICKED(IDC_MONITORING, &CIO_board_usb_ethDlg::OnBnClickedMonitoring)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_LOAD_HEX, &CIO_board_usb_ethDlg::OnBnClickedLoadHex)
	ON_BN_CLICKED(IDC_CONNECT_BOOTLOADER, &CIO_board_usb_ethDlg::OnBnClickedConnectBootloader)
	ON_BN_CLICKED(IDC_BOARD_IDENTIFICATION, &CIO_board_usb_ethDlg::OnBnClickedBoardIdentification)
	ON_BN_CLICKED(IDC_CALIB_CENTER_AUTO, &CIO_board_usb_ethDlg::OnBnClickedCalibCenterAuto)
END_MESSAGE_MAP()


// CIO_board_usb_ethDlg message handlers

BOOL CIO_board_usb_ethDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();
	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	for(unsigned int i=0;i<BOARD_MODEL_1_DI;i++)
		m_in[i].SetBitmap(bitmap_off);
	
	for(unsigned int i=0;i<BOARD_MODEL_1_DO;i++)
		((CButton *)GetDlgItem(GetOutButtonId(i)))->SetIcon(icon_unknown);

	for(unsigned int i=0;i<BOARD_MODEL_1_AI;i++)
	{
		m_progress_ai[i].SetRange(0,10000);
		m_progress_ai[i].SetPos(0);
		m_progress_ai[i].SetBarColor(RGB(255, 0, 10));   
		m_progress_ai[i].SetStep(1);
	}

	m_scroll_pwm1.SetScrollRange(0,1023, false);
	m_scroll_pwm1.SetScrollPos(0);

	m_scroll_pwm2.SetScrollRange(0,1023, false);
	m_scroll_pwm2.SetScrollPos(0);

	m_ip.SetAddress(192,168,110,77);
	m_settings_ip.SetAddress(192,168,110,77);
	m_settings_mask.SetAddress(255,255,255,0);
	m_settings_gw.SetAddress(192,168,110,1);
	return TRUE;
}

void CIO_board_usb_ethDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

void CIO_board_usb_ethDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CIO_board_usb_ethDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



int CIO_board_usb_ethDlg::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CDialogEx::OnCreate(lpCreateStruct) == -1)
		return -1;

	SetTimer(0,50,NULL);

	return 0;
}


void CIO_board_usb_ethDlg::OnClose()
{
	KillTimer(0);

	CDialogEx::OnClose();
}


void CIO_board_usb_ethDlg::OnTimer(UINT_PTR nIDEvent)
{
	Update();

	if(bootloader)
	{
		unsigned progress;
		switch(bootloader->GetBootStatus(progress))
		{ 
		case BOOT_STATUS_BAD_FILE:
			SetDlgItemText(IDC_BOOT_STATUS,"BOOT_STATUS_BAD_FILE");
			break;
		case BOOT_STATUS_WAIT_FOR_CONNECTION:
			SetDlgItemText(IDC_BOOT_STATUS,"BOOT_STATUS_WAIT_FOR_CONNECTION");
			break;
		case BOOT_STATUS_ERASE:
			SetDlgItemText(IDC_BOOT_STATUS,"BOOT_STATUS_ERASE");
			break;
		case BOOT_STATUS_RUNNING:
			{
				CString t;
				t.Format("BOOT_STATUS_RUNNING: %u",progress);
				SetDlgItemText(IDC_BOOT_STATUS,t.GetBuffer(0));
			}
			break;
		case BOOT_STATUS_DONE:
			SetDlgItemText(IDC_BOOT_STATUS,"BOOT_STATUS_DONE");
			break;
		case BOOT_STATUS_BOARD_NOT_READY:
			SetDlgItemText(IDC_BOOT_STATUS,"BOOT_STATUS_BOARD_NOT_READY");
			break;
		}
		GetDlgItem(IDC_BOOT_STATUS)->UpdateData(FALSE);
	}

	CDialogEx::OnTimer(nIDEvent);
}


void CIO_board_usb_ethDlg::OnBnClickedOk()
{
	//CDialogEx::OnOK();
}


void CIO_board_usb_ethDlg::OnBnClickedCancel()
{
	if(io_board)
	{
		delete io_board;
		io_board = NULL;
	}
	DestroyIcon(icon_unknown);
	CDialogEx::OnCancel();
}

int CIO_board_usb_ethDlg::GetOutButtonId(int index)
{
	switch(index)
	{
	case 0: return IDC_OUT1;
	case 1: return IDC_OUT2;
	case 2: return IDC_OUT3;
	case 3: return IDC_OUT4;
	case 4: return IDC_OUT5;
	case 5: return IDC_OUT6;
	case 6: return IDC_OUT7;
	case 7: return IDC_OUT8;
	case 8: return IDC_OUT9;
	case 9: return IDC_OUT10;
	case 10: return IDC_OUT11;
	case 11: return IDC_OUT12;
	case 12: return IDC_OUT13;
	case 13: return IDC_OUT14;
	case 14: return IDC_OUT15;
	case 15: return IDC_OUT16;
	}
	return IDC_OUT1;
}


int CIO_board_usb_ethDlg::GetAIValueId(int index)
{
	switch(index)
	{
	case 0: return IDC_AI_EDIT1;
	case 1: return IDC_AI_EDIT2;
	case 2: return IDC_AI_EDIT3;
	case 3: return IDC_AI_EDIT4;
	case 4: return IDC_AI_EDIT5;
	case 5: return IDC_AI_EDIT6;
	case 6: return IDC_AI_EDIT7;
	case 7: return IDC_AI_EDIT8;
	case 8: return IDC_AI_EDIT9;
	case 9: return IDC_AI_EDIT10;
	}
	return IDC_AI_EDIT1;
}

void CIO_board_usb_ethDlg::Update()
{
	static bool first=true;
	if(io_board==NULL  || !io_board->IsDataReady())
	{
		first=true;
		return;
	}
	std::string dip ("DIP: ");
	dip.append(binary_print((unsigned char)io_board->GetDIP()));
	SetDlgItemText(IDC_DIP,dip.c_str());

	if(io_board->IsConnected())
		SetDlgItemText(IDC_STATUS,"Device ready");
	else
		SetDlgItemText(IDC_STATUS,"Device closed");

	for(unsigned int i=0;i<BOARD_MODEL_1_DI;i++)
	{
		if(io_board->GetDIState(i))
			m_in[i].SetBitmap(bitmap_on);
		else
			m_in[i].SetBitmap(bitmap_off);
	}
	DO_STATE req_state;
	if(m_do_mode==0 && m_monitoring==FALSE)
	{
		for(unsigned int i=0;i<BOARD_MODEL_1_DO;i++)
		{
			req_state = io_board->GetDORequestedState(i);
			if(req_state==DO_STATE_OFF)
				{((CButton *)GetDlgItem(GetOutButtonId(i)))->SetIcon(icon_off);}
			else if(req_state==DO_STATE_ON)
				{((CButton *)GetDlgItem(GetOutButtonId(i)))->SetIcon(icon_on);}

			if(req_state==DO_STATE_ON)
				m_out[i]=TRUE;
			else if(req_state==DO_STATE_OFF)
				m_out[i]=FALSE;
		}
	}
	else
	{		
		for(unsigned int i=0;i<BOARD_MODEL_1_DO;i++)
		{
			if(io_board->GetDORealState(i)==false)
				{((CButton *)GetDlgItem(GetOutButtonId(i)))->SetIcon(icon_off);}
			else
				{((CButton *)GetDlgItem(GetOutButtonId(i)))->SetIcon(icon_on);}
			req_state = io_board->GetDORequestedState(i);
			if(req_state==DO_STATE_ON)
				m_out[i]=TRUE;
			else if(req_state==DO_STATE_OFF)
				m_out[i]=FALSE;		
		}
	}
	if(first)
	{
		first=false;
		UpdateData(FALSE);
	}
	for(unsigned int i=0;i<BOARD_MODEL_1_AI;i++)
	{
		m_ai[i] = io_board->GetAIState(i);
		SetDlgItemInt(GetAIValueId(i),io_board->GetAIState(i));
		m_progress_ai[i].SetPos(m_ai[i]);
		m_progress_ai[i].UpdateData(FALSE);
	}
}

DO_STATE CIO_board_usb_ethDlg::OutputValue(BOOL button_value, int mode, bool once)
{
	if(mode==0)
	{
		if(button_value)
			return DO_STATE_ON;
		else
			return DO_STATE_OFF;
	}
	if(mode==1)
	{
		return DO_STATE_OFF;
	}
	else
	{
		if(once==false)
		{
			switch(mode)
			{
			case 2: return DO_STATE_BLINK_100MS;
			case 3: return DO_STATE_BLINK_250MS;
			case 4: return DO_STATE_BLINK_500MS;
			case 5: return DO_STATE_BLINK_1000MS;
			case 6: return DO_STATE_BLINK_1500MS;
			case 7: return DO_STATE_BLINK_2000MS;
			default:return DO_STATE_OFF;
			}
		}
		else
		{
			switch(mode)
			{
			case 2: return DO_STATE_BLINK_ONCE_100MS;
			case 3: return DO_STATE_BLINK_ONCE_250MS;
			case 4: return DO_STATE_BLINK_ONCE_500MS;
			case 5: return DO_STATE_BLINK_ONCE_1000MS;
			case 6: return DO_STATE_BLINK_ONCE_1500MS;
			case 7: return DO_STATE_BLINK_ONCE_2000MS;
			default:return DO_STATE_OFF;
			}
		}
	}
}

void CIO_board_usb_ethDlg::OnBnClickedOut1()
{
	UpdateData(TRUE);
	if(m_do_mode!=0)
	{
		m_out[0]=FALSE;
		UpdateData(FALSE);
	}
	if(io_board) io_board->SetDOState(0,OutputValue(m_out[0],m_do_mode,m_blink_once ? true : false));
}


void CIO_board_usb_ethDlg::OnBnClickedOut2()
{
	UpdateData(TRUE);
	if(m_do_mode!=0)
	{
		m_out[1]=FALSE;
		UpdateData(FALSE);
	}
	if(io_board) io_board->SetDOState(1,OutputValue(m_out[1],m_do_mode,m_blink_once ? true : false));
}


void CIO_board_usb_ethDlg::OnBnClickedOut3()
{
	UpdateData(TRUE);
	if(m_do_mode!=0)
	{
		m_out[2]=FALSE;
		UpdateData(FALSE);
	}
	if(io_board) io_board->SetDOState(2,OutputValue(m_out[2],m_do_mode,m_blink_once ? true : false));
}


void CIO_board_usb_ethDlg::OnBnClickedOut4()
{
	UpdateData(TRUE);
	if(m_do_mode!=0)
	{
		m_out[3]=FALSE;
		UpdateData(FALSE);
	}
	if(io_board) io_board->SetDOState(3,OutputValue(m_out[3],m_do_mode,m_blink_once ? true : false));
}


void CIO_board_usb_ethDlg::OnBnClickedOut5()
{
	UpdateData(TRUE);
	if(m_do_mode!=0)
	{
		m_out[4]=FALSE;
		UpdateData(FALSE);
	}
	if(io_board) io_board->SetDOState(4,OutputValue(m_out[4],m_do_mode,m_blink_once ? true : false));
}


void CIO_board_usb_ethDlg::OnBnClickedOut6()
{
	UpdateData(TRUE);
	if(m_do_mode!=0)
	{
		m_out[5]=FALSE;
		UpdateData(FALSE);
	}
	if(io_board) io_board->SetDOState(5,OutputValue(m_out[5],m_do_mode,m_blink_once ? true : false));
}


void CIO_board_usb_ethDlg::OnBnClickedOut7()
{
	UpdateData(TRUE);
	if(m_do_mode!=0)
	{
		m_out[6]=FALSE;
		UpdateData(FALSE);
	}
	if(io_board) io_board->SetDOState(6,OutputValue(m_out[6],m_do_mode,m_blink_once ? true : false));
}


void CIO_board_usb_ethDlg::OnBnClickedOut8()
{
	UpdateData(TRUE);
	if(m_do_mode!=0)
	{
		m_out[7]=FALSE;
		UpdateData(FALSE);
	}
	if(io_board) io_board->SetDOState(7,OutputValue(m_out[7],m_do_mode,m_blink_once ? true : false));
}

void CIO_board_usb_ethDlg::OnBnClickedOut9()
{
	UpdateData(TRUE);
	if(m_do_mode!=0)
	{
		m_out[8]=FALSE;
		UpdateData(FALSE);
	}
	if(io_board) io_board->SetDOState(8,OutputValue(m_out[8],m_do_mode,m_blink_once ? true : false));
}

void CIO_board_usb_ethDlg::OnBnClickedOut10()
{
	UpdateData(TRUE);
	if(m_do_mode!=0)
	{
		m_out[9]=FALSE;
		UpdateData(FALSE);
	}
	if(io_board) io_board->SetDOState(9,OutputValue(m_out[9],m_do_mode,m_blink_once ? true : false));
}

void CIO_board_usb_ethDlg::OnBnClickedOut11()
{
	UpdateData(TRUE);
	if(m_do_mode!=0)
	{
		m_out[10]=FALSE;
		UpdateData(FALSE);
	}
	if(io_board) io_board->SetDOState(10,OutputValue(m_out[10],m_do_mode,m_blink_once ? true : false));
}

void CIO_board_usb_ethDlg::OnBnClickedOut12()
{
	UpdateData(TRUE);
	if(m_do_mode!=0)
	{
		m_out[11]=FALSE;
		UpdateData(FALSE);
	}
	if(io_board) io_board->SetDOState(11,OutputValue(m_out[11],m_do_mode,m_blink_once ? true : false));
}

void CIO_board_usb_ethDlg::OnBnClickedOut13()
{
	UpdateData(TRUE);
	if(m_do_mode!=0)
	{
		m_out[12]=FALSE;
		UpdateData(FALSE);
	}
	if(io_board) io_board->SetDOState(12,OutputValue(m_out[12],m_do_mode,m_blink_once ? true : false));
}

void CIO_board_usb_ethDlg::OnBnClickedOut14()
{
	UpdateData(TRUE);
	if(m_do_mode!=0)
	{
		m_out[13]=FALSE;
		UpdateData(FALSE);
	}
	if(io_board) io_board->SetDOState(13,OutputValue(m_out[13],m_do_mode,m_blink_once ? true : false));
}

void CIO_board_usb_ethDlg::OnBnClickedOut15()
{
	UpdateData(TRUE);
	if(m_do_mode!=0)
	{
		m_out[14]=FALSE;
		UpdateData(FALSE);
	}
	if(io_board) io_board->SetDOState(14,OutputValue(m_out[14],m_do_mode,m_blink_once ? true : false));
}

void CIO_board_usb_ethDlg::OnBnClickedOut16()
{
	UpdateData(TRUE);
	if(m_do_mode!=0)
	{
		m_out[15]=FALSE;
		UpdateData(FALSE);
	}
	if(io_board) io_board->SetDOState(15,OutputValue(m_out[15],m_do_mode,m_blink_once ? true : false));
}

void CIO_board_usb_ethDlg::OnBnClickedDoMode()
{
	UpdateData(TRUE);
}


void CIO_board_usb_ethDlg::OnBnClickedConnectionTypeUsb()
{
	UpdateData(TRUE);
}


void CIO_board_usb_ethDlg::OnBnClickedConnectionTypeTcp()
{
	UpdateData(TRUE);
}


void CIO_board_usb_ethDlg::OnBnClickedConnect()
{
	UpdateData(TRUE);
	if(m_connect)
	{
		if(m_connection_type==0)
		{
			io_board = new CIOBoardUSB(CANLAB_BOARD_MODEL_1, IO_BOARD_VID, IO_BOARD_PID, NULL, true, m_monitoring ? true : false);
			GetDlgItem(IDC_CALIB_MIN)->EnableWindow(FALSE); 
			GetDlgItem(IDC_CALIB_CENTER)->EnableWindow(FALSE); 
			GetDlgItem(IDC_CALIB_CENTER_AUTO)->EnableWindow(FALSE); 
			GetDlgItem(IDC_CALIB_MAX)->EnableWindow(FALSE); 
			GetDlgItem(IDC_CALIB_SAVE)->EnableWindow(FALSE); 
			GetDlgItem(IDC_CALIB_RESET)->EnableWindow(FALSE); 
			GetDlgItem(IDC_SETTINGS_SET)->EnableWindow(FALSE); 
			GetDlgItem(IDC_SETTINGS_GET)->EnableWindow(FALSE); 
			GetDlgItem(IDC_RESET)->EnableWindow(FALSE); 
			GetDlgItem(IDC_BOARD_IDENTIFICATION)->EnableWindow(FALSE); 
		}
		else if(m_connection_type==1)
		{
			BYTE ip_field[4];
			m_ip.GetAddress(ip_field[0], ip_field[1], ip_field[2], ip_field[3]);
			std::string ip = string_format("%d.%d.%d.%d",(int)ip_field[0], (int)ip_field[1], (int)ip_field[2], (int)ip_field[3]);
			io_board = new CIOBoardTCP(CANLAB_BOARD_MODEL_1, ip, m_port, true, m_monitoring ? true : false);
			GetDlgItem(IDC_CALIB_MIN)->EnableWindow(TRUE); 
			GetDlgItem(IDC_CALIB_CENTER)->EnableWindow(TRUE); 
			GetDlgItem(IDC_CALIB_CENTER_AUTO)->EnableWindow(TRUE); 
			GetDlgItem(IDC_CALIB_MAX)->EnableWindow(TRUE); 
			GetDlgItem(IDC_CALIB_SAVE)->EnableWindow(TRUE); 
			GetDlgItem(IDC_CALIB_RESET)->EnableWindow(TRUE); 
			GetDlgItem(IDC_SETTINGS_SET)->EnableWindow(TRUE); 
			GetDlgItem(IDC_SETTINGS_GET)->EnableWindow(TRUE);
			GetDlgItem(IDC_RESET)->EnableWindow(TRUE);
			GetDlgItem(IDC_BOARD_IDENTIFICATION)->EnableWindow(TRUE); 
		}
		/*
		while(io_board->IsDataReady()==false);
		std::uint64_t di= io_board->GetDI();
		io_board->SetDOStateByMask(0x0F,DO_STATE_OFF);
		io_board->SetDOStateByMask(0xF0,DO_STATE_ON);
		*/
	}
	else
	{
		delete io_board;
		io_board = NULL;
	}
}


void CIO_board_usb_ethDlg::OnBnClickedSettingsSet()
{
	if(io_board==NULL)
		return;
	UpdateData(TRUE);
	CANLAB_IO_BOARD_MODEL_1_SETTINGS settings;

	settings.do_init[0]=0;
	settings.do_init[1]=0;
	if(m_settings_startup[0])	settings.do_init[0] |=0x01;
	if(m_settings_startup[1])	settings.do_init[0] |=0x02;
	if(m_settings_startup[2])	settings.do_init[0] |=0x04;
	if(m_settings_startup[3])	settings.do_init[0] |=0x08;
	if(m_settings_startup[4])	settings.do_init[0] |=0x10;
	if(m_settings_startup[5])	settings.do_init[0] |=0x20;
	if(m_settings_startup[6])	settings.do_init[0] |=0x40;
	if(m_settings_startup[7])	settings.do_init[0] |=0x80;

	if(m_settings_startup[8])	settings.do_init[1] |=0x01;
	if(m_settings_startup[9])	settings.do_init[1] |=0x02;
	if(m_settings_startup[10])	settings.do_init[1] |=0x04;
	if(m_settings_startup[11])	settings.do_init[1] |=0x08;
	if(m_settings_startup[12])	settings.do_init[1] |=0x10;
	if(m_settings_startup[13])	settings.do_init[1] |=0x20;
	if(m_settings_startup[14])	settings.do_init[1] |=0x40;
	if(m_settings_startup[15])	settings.do_init[1] |=0x80;

	settings.ai_enable[0]=settings.ai_enable[1]=0;
	if(m_ai_enable[0])	settings.ai_enable[0] |=0x01;
	if(m_ai_enable[1])	settings.ai_enable[0] |=0x02;
	if(m_ai_enable[2])	settings.ai_enable[0] |=0x04;
	if(m_ai_enable[3])	settings.ai_enable[0] |=0x08;
	if(m_ai_enable[4])	settings.ai_enable[0] |=0x10;
	if(m_ai_enable[5])	settings.ai_enable[0] |=0x20;
	if(m_ai_enable[6])	settings.ai_enable[0] |=0x40;
	if(m_ai_enable[7])	settings.ai_enable[0] |=0x80;

	if(m_ai_enable[8])	settings.ai_enable[1] |=0x01;
	if(m_ai_enable[9])	settings.ai_enable[1] |=0x02;

	settings.pwm_init[0] = m_pwm_init_1;
	settings.pwm_init[1] = m_pwm_init_2;

	settings.mac[0] = m_mac1;
	settings.mac[1] = m_mac2;
	settings.mac[2] = m_mac3;
	settings.mac[3] = m_mac4;
	settings.mac[4] = m_mac5;
	settings.mac[5] = m_mac6;

	settings.port = m_settings_port;
	
	m_settings_ip.GetAddress(settings.ip[0], settings.ip[1], settings.ip[2], settings.ip[3]);
	m_settings_mask.GetAddress(settings.mask[0], settings.mask[1], settings.mask[2], settings.mask[3]);
	m_settings_gw.GetAddress(settings.gw[0], settings.gw[1], settings.gw[2], settings.gw[3]);

	if(io_board->GetConnectionType()==IO_BOARD_CON_TCP) 
	{
		CIOBoardTCP *tcpdynamic = reinterpret_cast<CIOBoardTCP*>(io_board);
		if(tcpdynamic)
			tcpdynamic->SendSettings((void*)&settings);
	}
}

void CIO_board_usb_ethDlg::OnBnClickedBoardIdentification()
{
	if(io_board->GetConnectionType()==IO_BOARD_CON_TCP) 
	{
		CIOBoardTCP *tcpdynamic = reinterpret_cast<CIOBoardTCP*>(io_board);
		if(tcpdynamic)
		{
			std::string fw;
			std::string hw;
			if(tcpdynamic->GetIdentification(fw,hw))
			{
				CString s;
				s.Format("FW: %s  ,  HW: %s",fw.c_str(),hw.c_str());
				MessageBox(s.GetBuffer(0),"Identification");
			}
		}
	}
}


void CIO_board_usb_ethDlg::OnBnClickedCalibMin()
{
	UpdateData(TRUE);
	if(io_board->GetConnectionType()==IO_BOARD_CON_TCP) 
	{
		CIOBoardTCP *tcpdynamic = reinterpret_cast<CIOBoardTCP*>(io_board);
		if(tcpdynamic)
			tcpdynamic->Calibration(CALIBRATION_POINT_MIN,m_calib_select);
	}
}


void CIO_board_usb_ethDlg::OnBnClickedCalibCenter()
{
	UpdateData(TRUE);
	if(io_board->GetConnectionType()==IO_BOARD_CON_TCP) 
	{
		CIOBoardTCP *tcpdynamic = reinterpret_cast<CIOBoardTCP*>(io_board);
		if(tcpdynamic)
			tcpdynamic->Calibration(CALIBRATION_POINT_CENTER,m_calib_select);
	}
}

void CIO_board_usb_ethDlg::OnBnClickedCalibCenterAuto()
{
	UpdateData(TRUE);
	if(io_board->GetConnectionType()==IO_BOARD_CON_TCP) 
	{
		CIOBoardTCP *tcpdynamic = reinterpret_cast<CIOBoardTCP*>(io_board);
		if(tcpdynamic)
			tcpdynamic->Calibration(CALIBRATION_POINT_CENTER_AUTO,m_calib_select);
	}
}



void CIO_board_usb_ethDlg::OnBnClickedCalibMax()
{
	UpdateData(TRUE);
	if(io_board->GetConnectionType()==IO_BOARD_CON_TCP) 
	{
		CIOBoardTCP *tcpdynamic = reinterpret_cast<CIOBoardTCP*>(io_board);
		if(tcpdynamic)
			tcpdynamic->Calibration(CALIBRATION_POINT_MAX,m_calib_select);
	}
}


void CIO_board_usb_ethDlg::OnBnClickedCalibSave()
{
	UpdateData(TRUE);
	if(io_board->GetConnectionType()==IO_BOARD_CON_TCP) 
	{
		CIOBoardTCP *tcpdynamic = reinterpret_cast<CIOBoardTCP*>(io_board);
		if(tcpdynamic)
			tcpdynamic->Calibration(CALIBRATION_SAVE);
	}
}


void CIO_board_usb_ethDlg::OnBnClickedCalibReset()
{
	UpdateData(TRUE);
	if(io_board->GetConnectionType()==IO_BOARD_CON_TCP) 
	{
		CIOBoardTCP *tcpdynamic = reinterpret_cast<CIOBoardTCP*>(io_board);
		if(tcpdynamic)
			tcpdynamic->Calibration(CALIBRATION_RESET);
	}
}


void CIO_board_usb_ethDlg::OnBnClickedReset()
{
	if(io_board->GetConnectionType()==IO_BOARD_CON_TCP) 
	{
		CIOBoardTCP *tcpdynamic = reinterpret_cast<CIOBoardTCP*>(io_board);
		if(tcpdynamic)
		{
			tcpdynamic->ResetBoard();
			Sleep(50);
			m_connect=FALSE;
			UpdateData(FALSE);
			OnBnClickedConnect();
		}
	}
}


void CIO_board_usb_ethDlg::OnBnClickedSettingsGet()
{
	if(io_board->GetConnectionType()==IO_BOARD_CON_TCP) 
	{
		CIOBoardTCP *tcpdynamic = reinterpret_cast<CIOBoardTCP*>(io_board);
		if(tcpdynamic)
		{
			CANLAB_IO_BOARD_MODEL_1_SETTINGS settings;
			if(tcpdynamic->GetSettings((void*)&settings)==true)
			{
				m_ai_enable[0] = (settings.ai_enable[0]&0x01) ? TRUE : FALSE;
				m_ai_enable[1] = (settings.ai_enable[0]&0x02) ? TRUE : FALSE;
				m_ai_enable[2] = (settings.ai_enable[0]&0x04) ? TRUE : FALSE;
				m_ai_enable[3] = (settings.ai_enable[0]&0x08) ? TRUE : FALSE;
				m_ai_enable[4] = (settings.ai_enable[0]&0x10) ? TRUE : FALSE;
				m_ai_enable[5] = (settings.ai_enable[0]&0x20) ? TRUE : FALSE;
				m_ai_enable[6] = (settings.ai_enable[0]&0x40) ? TRUE : FALSE;
				m_ai_enable[7] = (settings.ai_enable[0]&0x80) ? TRUE : FALSE;
				m_ai_enable[8] = (settings.ai_enable[1]&0x01) ? TRUE : FALSE;
				m_ai_enable[9]= (settings.ai_enable[1]&0x02) ? TRUE : FALSE;

				m_settings_startup[0] = (settings.do_init[0]&0x01) ? TRUE : FALSE;
				m_settings_startup[1] = (settings.do_init[0]&0x02) ? TRUE : FALSE;
				m_settings_startup[2] = (settings.do_init[0]&0x04) ? TRUE : FALSE;
				m_settings_startup[3] = (settings.do_init[0]&0x08) ? TRUE : FALSE;
				m_settings_startup[4] = (settings.do_init[0]&0x10) ? TRUE : FALSE;
				m_settings_startup[5] = (settings.do_init[0]&0x20) ? TRUE : FALSE;
				m_settings_startup[6] = (settings.do_init[0]&0x40) ? TRUE : FALSE;
				m_settings_startup[7] = (settings.do_init[0]&0x80) ? TRUE : FALSE;

				m_settings_startup[8]  = (settings.do_init[1]&0x01) ? TRUE : FALSE;
				m_settings_startup[9]  = (settings.do_init[1]&0x02) ? TRUE : FALSE;
				m_settings_startup[10] = (settings.do_init[1]&0x04) ? TRUE : FALSE;
				m_settings_startup[11] = (settings.do_init[1]&0x08) ? TRUE : FALSE;
				m_settings_startup[12] = (settings.do_init[1]&0x10) ? TRUE : FALSE;
				m_settings_startup[13] = (settings.do_init[1]&0x20) ? TRUE : FALSE;
				m_settings_startup[14] = (settings.do_init[1]&0x40) ? TRUE : FALSE;
				m_settings_startup[15] = (settings.do_init[1]&0x80) ? TRUE : FALSE;

				m_mac1 = settings.mac[0];
				m_mac2 = settings.mac[1];
				m_mac3 = settings.mac[2];
				m_mac4 = settings.mac[3];
				m_mac5 = settings.mac[4];
				m_mac6 = settings.mac[5];

				m_settings_port = settings.port;

				m_pwm_init_1 = settings.pwm_init[0];
				m_pwm_init_2 = settings.pwm_init[1];

				m_settings_ip.SetAddress(settings.ip[0],settings.ip[1],settings.ip[2],settings.ip[3]);
				m_settings_mask.SetAddress(settings.mask[0],settings.mask[1],settings.mask[2],settings.mask[3]);
				m_settings_gw.SetAddress(settings.gw[0],settings.gw[1],settings.gw[2],settings.gw[3]);

				UpdateData(FALSE);
			}
		}
	}
}


void CIO_board_usb_ethDlg::OnBnClickedMonitoring()
{
	UpdateData(TRUE);
}


void CIO_board_usb_ethDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
   int minpos, maxpos, curpos;

	UpdateData(true);
    pScrollBar->GetScrollRange(&minpos, &maxpos);
    curpos = pScrollBar->GetScrollPos();

    switch (nSBCode) {
      case SB_LEFT:
        curpos = minpos;
        break;

	  case SB_RIGHT:
        curpos = maxpos;
        break;

      case SB_LINELEFT:
        if( curpos > minpos ) curpos = max(minpos, curpos - 1);
        break;

      case SB_LINERIGHT:
        if( curpos < maxpos ) curpos = min(maxpos, curpos + 1);
        break;

      case SB_PAGELEFT:
        if( curpos > minpos ) curpos = max(minpos, curpos - 10);
        break;

      case SB_PAGERIGHT:
        if( curpos < maxpos ) curpos = min(maxpos, curpos + 10);
        break;

      case SB_THUMBPOSITION:
        curpos = nPos;
        break;

      case SB_THUMBTRACK:
        curpos = nPos;
        break;
    }
    pScrollBar->SetScrollPos(curpos);

	switch (pScrollBar->GetDlgCtrlID())
	{
	case IDC_SCROLLBAR_PWM1:
		m_pwm1 = curpos;
		if(io_board) io_board->SetPWMValue(0,m_pwm1);
		UpdateData(FALSE);
	break;
	case IDC_SCROLLBAR_PWM2:	
		m_pwm2 = curpos;
		if(io_board) io_board->SetPWMValue(1,m_pwm2);
		UpdateData(FALSE);
	break;
	}	
	CDialogEx::OnHScroll(nSBCode, nPos, pScrollBar);
}


void CIO_board_usb_ethDlg::OnBnClickedLoadHex()
{
	CFileDialog *dialog = new CFileDialog(true, "hex");
	dialog->m_ofn.lpstrFilter = "Config files *.hex\0*.HEX\0All files *.*\0*.*\0";
	if( dialog->DoModal() == IDOK ) 
	{
		m_filename_hex = dialog->GetPathName();
		UpdateData(FALSE);
	}
	delete dialog;
}


void CIO_board_usb_ethDlg::OnBnClickedConnectBootloader()
{
	UpdateData(TRUE);		
	if(m_connect_bootloader)
	{
		if(m_filename_hex.GetLength()<3)
		{
			OnBnClickedLoadHex();
		}
		BYTE ip_field[4];
		m_ip.GetAddress(ip_field[0], ip_field[1], ip_field[2], ip_field[3]);
		std::string ip = string_format("%d.%d.%d.%d",(int)ip_field[0], (int)ip_field[1], (int)ip_field[2], (int)ip_field[3]);
		bootloader = new CIOBoardTCPBootloader(ip, m_port, std::string(m_filename_hex.GetBuffer(0)), true);
	}
	else
	{
		delete bootloader;
		bootloader = NULL;
	}
}

