
// IO_board_usb_ethDlg.h : header file
//

#pragma once
#include "hidapi.h"
#include "afxwin.h"
#include "CIOboardUSB.h"
#include "CIOboardTCP.h"
#include "CIOboardTCPBootloader.h"
#include "afxcmn.h"

// CIO_board_usb_ethDlg dialog
class CIO_board_usb_ethDlg : public CDialogEx
{
// Construction
public:
	CIO_board_usb_ethDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_IO_BOARD_USB_ETH_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;
	int GetOutButtonId(int index);
	int GetAIValueId(int index);
	DO_STATE OutputValue(BOOL button_value, int mode, bool once);
	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
protected:
	CIOBoard *io_board;
	CIOBoardTCPBootloader *bootloader;

	bool change_outputs;
	HICON icon_unknown;
	HICON icon_on;
	HICON icon_on_err;
	HICON icon_off;
	HICON icon_off_err;
	HBITMAP bitmap_on;
	HBITMAP bitmap_off; 
public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnClose();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
	void Update();
	CStatic m_in[24];
	int m_do_mode;
	afx_msg void OnBnClickedOut1();
	afx_msg void OnBnClickedOut2();
	afx_msg void OnBnClickedOut3();
	afx_msg void OnBnClickedOut4();
	afx_msg void OnBnClickedOut5();
	afx_msg void OnBnClickedOut6();
	afx_msg void OnBnClickedOut7();
	afx_msg void OnBnClickedOut8();
	afx_msg void OnBnClickedOut9();
	afx_msg void OnBnClickedOut10();
	afx_msg void OnBnClickedOut11();
	afx_msg void OnBnClickedOut12();
	afx_msg void OnBnClickedOut13();
	afx_msg void OnBnClickedOut14();
	afx_msg void OnBnClickedOut15();
	afx_msg void OnBnClickedOut16();
	BOOL m_out[16];
	CProgressCtrl m_progress_ai[10];
	UINT m_ai[10];
	afx_msg void OnBnClickedDoMode();
	afx_msg void OnBnClickedConnectionTypeUsb();
	afx_msg void OnBnClickedConnectionTypeTcp();
	int m_connection_type;
	CIPAddressCtrl m_ip;
	UINT m_port;
	BOOL m_connect;
	afx_msg void OnBnClickedConnect();
	afx_msg void OnBnClickedSettingsSet();
	BOOL m_settings_startup[16];
	BOOL m_ai_enable[10];
	UINT m_mac1;
	UINT m_mac2;
	UINT m_mac3;
	UINT m_mac4;
	UINT m_mac5;
	UINT m_mac6;
	UINT m_settings_port;
	CIPAddressCtrl m_settings_ip;
	CIPAddressCtrl m_settings_mask;
	CIPAddressCtrl m_settings_gw;
	int m_calib_select;
	afx_msg void OnBnClickedCalibMin();
	afx_msg void OnBnClickedCalibCenter();
	afx_msg void OnBnClickedCalibMax();
	afx_msg void OnBnClickedCalibSave();
	afx_msg void OnBnClickedCalibReset();
	afx_msg void OnBnClickedReset();
	afx_msg void OnBnClickedSettingsGet();
	BOOL m_monitoring;
	afx_msg void OnBnClickedMonitoring();
	CScrollBar m_scroll_pwm1;
	CScrollBar m_scroll_pwm2;
	UINT m_pwm1;
	UINT m_pwm2;
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnBnClickedLoadHex();
	CString m_filename_hex;
	BOOL m_connect_bootloader;
	afx_msg void OnBnClickedConnectBootloader();
	afx_msg void OnBnClickedBoardIdentification();
	afx_msg void OnBnClickedCalibCenterAuto();
	UINT m_pwm_init_1;
	UINT m_pwm_init_2;
	BOOL m_blink_once;
};
