#include <iostream>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <termios.h>
#include <time.h>

#include "CIOboardTCP.h"
#include "CIOboardUSB.h"

using namespace std;

int getkey() {
	int character;
	struct termios orig_term_attr;
	struct termios new_term_attr;
	tcgetattr(fileno(stdin), &orig_term_attr);
	memcpy(&new_term_attr, &orig_term_attr, sizeof(struct termios));
	new_term_attr.c_lflag &= ~(ECHO | ICANON);
	new_term_attr.c_cc[VTIME] = 0;
	new_term_attr.c_cc[VMIN] = 0;
	tcsetattr(fileno(stdin), TCSANOW, &new_term_attr);
	character = fgetc(stdin);
	tcsetattr(fileno(stdin), TCSANOW, &orig_term_attr);
	return character;
}

int main(int argc, char *argv[])
{
	int key;
	CIOBoard *board;
	//board = new CIOBoardTCP(CANLAB_BOARD_MODEL_1, std::string("192.168.110.77"), 5000, true, false);
	board = new CIOBoardUSB(CANLAB_BOARD_MODEL_1, IO_BOARD_VID, IO_BOARD_PID, NULL, true, false);
	for (;;) 
	{
		key = getkey();
		if(key=='1')
		{
			board->SetDOState(1, DO_STATE_ON);			
		}
		else if (key == '0')
		{
			board->SetDOState(1, DO_STATE_OFF);			
		}	
		else if ((key == 'e') || (key == 'E'))
		{
			break;			
		}
		usleep(10000);		
	}
	delete board;
	return 0;
}